from ppms.ppms_cu import Access

text_constants = {
        # <internal message id>: (<text constant id>, <alternative text>),
        'missing_license':('001333', 'PLANTA license not available. System calendar cannot be accessed'),
        'no_calid':('001335', 'Calendar ID is not accessible'),
        'invalid_resource':('001336', 'Resource assignment points to invalid Resource'),
        'psp_generation':('001337', 'PSP code generation started'),
        'unsuccessful_export':('001338', 'Export could not be finished successfully. Please refer to the log.'),
        'export_transfer':('001339', 'Transferring the export result...'),
        'export_exception':('001340', 'Export had an unexpected exception: '),
        'standard_week_dis':('001341', 'The standard week DIs are missing, a default standard week will be used instead.'),
        'standard_week_not_set':('001342', 'The standard week of calendar {0} is not set. Please set the standard week to obtain a smaller export output.'),
        'syscalrec_fetch_failed':('001343', 'Calendar record for the system calendar could not be accessed!'),
        'calrec_fetch_failed':('001344', 'Calendar record for calendar {0} could not be accessed!'),
        'cal_transformation':('001345', 'Beginning calendar export...'),
        'syscal_fetch_failed':('001346', 'System calendar could not be accessed!'),
        'resource_wt_too_big':('001347', 'Resource {0} has a working time greater than 24 hours, the standard working time of 8 hours will be used instead'),
        'no_base_cal':('001348', 'Base calendar for resource {0} could not be built.'),
        'resource_transformation':('001349', 'Exporting resource {0}'),
        'resource_type_invalid':('001350', 'Resource {0} is not material or work resource, other resource types are ignored.'),
        'assignment_transformation':('001351', 'Exporting assignment of resource {0} to task {1}'),
        'project_export':('001352', 'Beginning export of project {0}...'),
        'task_transformation':('001353', 'Exporting task {0}'),
        'link_external_task':('001354', 'Task {0} has a link to a task in an external project. The link cannot be exported.'),
        'invalid_task_link':('001355', 'Task {0} has a link to invalid task {1}'),
        'no_psp':('001356', 'PSP Code was not calculated for task {0}, the structure might not be exported correctly!'),
        'represents_subproject':('001357', 'Task {0} represents subproject {1}'),
        'subproj_prefix':('001358', 'Subproject: {0}'),
        'scheduled':('001359', 'Schedule module content refreshed'),
        'scheduling_failed':('001360', 'Refreshing Schedule module content did not work, please reload the module and run capacity scheduling'),
        'import_transfer':('001361', 'Project successfully loaded, starting import...'),
        'import_parsing_failed':('001362', 'Project loading was not successful: {0}'),
        'import_transfer_failed':('001363', 'Project file could not be opened!'),
        'planta_reimport':('001364', 'Project was originally created by PLANTA Project, a merge will be attempted'),
        'import_project':('001365', 'Project head record imported to project {0}'),
        'no_requested_dates':('001366', 'Please activate the checkbox "Task requested dates" in the model parameters, otherwise the import result will not be correct'),
        'fixing_tasks':('001367', '''The Checkbox "Consider today's date" activated in model parameters, tasks will be fixed'''),
        'exception_exit':('001368', 'An unhandled exception occured: {0}. Exiting.'),
        'unlinked_record_deletion':('001369', '{0} records that have no connection to existing tasks deleted '),
        'msp_deleted_task':('001370', 'Task {0} was deleted in Microsoft Project'),
        'unchanged_task':('001372', 'Task {0} was not changed in Microsoft Project'),
        'changed_task':('001373', 'Task {0} was changed in Microsoft Project'),
        'planta_deleted_task':('001374', 'Task {0} does not exist in PLANTA Project anymore'),
        'msp_added_task':('001375', 'Task {0} was created in Microsoft Project'),
        'task_reimport_failed':('001376', 'Task {0} could not be imported'),
        'msp_link_table_cleaned':('001377', 'MSPI Link table cleared: {0} records deleted'),
        'msp_link_added':('001378', 'Link record for tasks {0} and {1} was created in the MSPI Link table'),
        'msp_link_addition_failed':('001379', 'Link record for tasks {0} and {1} could not be created in the MSPI Link table'),
        'task_import':('001380', 'Task {0} successfully imported (MS Project task ID: {1})'),
        'invalid_task':('001381', 'Task record with task ID {0} is not valid: {1}'),
        'task_linked':('001382', 'Task {0}(in Microsoft Project task {1}) has a link to task {2} (in Microsoft Project task {3})'),
        'task_link_failed':('001383', 'Link from task {0} to task {1} could not be created.'),
        'linked_task_missing':('001384', 'Ignoring link from non-existant task {0} to task {1}.'),
        'no_msp_edit':('001415', 'Project was not edited by MS Project since the export, thus imported summary tasks will not have dates'),
        'cal_not_covering_project':('001510', 'Calendar {0} is not covering the project boundaries, using standard working days whenever needed.')
    }

def get_const(name):
    text = None
    if name in text_constants:
        if text_constants[name][0]:
            text = Access().get_text_constant(text_constants[name][0])
        if not text:
            text = text_constants[name][1]
    if not text: text = name
    return text