from .mspdi_2003_classes import *
from . import info_handler
from . import messages as msg
fields = {
            'TaskID':('188743731', 'PLANTA TaskID'),
            'TaskHash':('188743734', 'PLANTA TaskHash'),
            'MSPID':('188743737', 'PLANTA MSPID')
         }

def has_planta_field_cust(project_inst):
    existing_fields = {(fcust.get_FieldID(), fcust.get_Alias()) for fcust \
        in project_inst.get_ExtendedAttributes().get_ExtendedAttribute()}
    planta_fields = {(fields[id][0], fields[id][1]) for id in fields}
    if planta_fields <= existing_fields:
        return True

def add_cust(attr_cust_container, id):
    attr = ExtendedAttribute(FieldID=fields[id][0],
        Alias=fields[id][1])
    attr_cust_container.add_ExtendedAttribute(attr)

def set_planta_field_cust(project_inst):
    ext_attrs = ExtendedAttributes()
    project_inst.set_ExtendedAttributes(ext_attrs)
    for id in fields:
        add_cust(ext_attrs, id)
    
def add_extended_field(task_obj, id_value_pair):
    id, value = id_value_pair
    ext_attrs = task_obj.get_ExtendedAttribute()
    existing_fields = [field.get_FieldID() for field in ext_attrs]
    if fields[id][0] in existing_fields:
        ext_attrs.remove(ext_attrs[existing_fields.index(fields[id][0])])
    ext_attr = ExtendedAttributeInstance(FieldID=fields[id][0], Value=value)
    task_obj.add_ExtendedAttribute(ext_attr)

def get_extended_field_value(task_obj, id):
    for field in task_obj.get_ExtendedAttribute():
        if field.get_FieldID() == fields[id][0]:
            return field.get_Value()
